#!/usr/bin/env jruby
# encoding: iso8859-1

# Test minimaliste de FFI (Foreign Function Interface)
# http://blog.headius.com/2008/10/ffi-for-ruby-now-available.html
# http://wmeissner.blogspot.com/2008/11/more-on-ruby-ffi.html
# http://pluskid.lifegoo.com/?p=370
#


# Si le module ci-dessus est dans un fichier spar glpk.rb
require "ffi-glpk"

# Pour viter de prfixer tous les appel par Glpk.xxxx
include Glpk

def glpk_test
    lp = glp_create_prob
    glp_set_prob_name lp, "rglpk_test_pb_name"

    # to verify that the name is readable from ruby
    name = glp_get_prob_name lp
    puts "Relecture du nom du pb : name=#{name}"

    glp_set_obj_dir lp, GLP_MAX
    dir = glp_get_obj_dir lp
    puts "Relecture de la direction d'optimisation du pb : dir=#{dir}"

    glp_add_rows lp, 3

    glp_set_row_name lp, 1, "p"
    glp_set_row_bnds lp, 1, GLP_UP, 0.0, 100.0
    glp_set_row_name lp, 2, "q"
    glp_set_row_bnds lp, 2, GLP_UP, 0.0, 600.0
    glp_set_row_name lp, 3, "r"
    glp_set_row_bnds lp, 3, GLP_UP, 0.0, 300.0

    glp_add_cols lp, 3
    glp_set_col_name lp, 1, "x1"
    glp_set_col_bnds lp, 1, GLP_LO, 0.0, 0.0
    glp_set_obj_coef lp, 1, 10.0

    glp_set_col_name lp, 2, "x2"
    glp_set_col_bnds lp, 2, GLP_LO, 0.0, 0.0
    glp_set_obj_coef lp, 2, 6.0

    glp_set_col_name lp, 3, "x3"
    glp_set_col_bnds lp, 3, GLP_LO, 0.0, 0.0
    glp_set_obj_coef lp, 3, 4.0


    glp_set_aij_coef 0, 0,  0.0   # first elem is unused by glpk
    glp_set_aij_coef 1, 1,  1.0
    glp_set_aij_coef 1, 2,  1.0
    glp_set_aij_coef 1, 3,  1.0
    glp_set_aij_coef 2, 1, 10.0
    glp_set_aij_coef 3, 1,  2.0
    glp_set_aij_coef 2, 2,  4.0
    glp_set_aij_coef 3, 2,  2.0
    glp_set_aij_coef 2, 3,  5.0
    glp_set_aij_coef 3, 3,  6.0
    glp_load_matrix2 lp
    glp_simplex lp, nil
    z = glp_get_obj_val lp
    x1 = glp_get_col_prim lp, 1
    x2 = glp_get_col_prim lp, 2
    x3 = glp_get_col_prim lp, 3
    printf "\n"
    printf "result is: z = %g; x1 = %g; x2 = %g; x3 = %g\n", z, x1, x2, x3
    printf "expected:  z = 733.333; x1 = 33.3333; x2 = 66.6667; x3 = 0\n"
    glp_delete_prob lp
    return 0;

end
glpk_test
puts "FINI !"
## ./
